diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 0f8ae794..e3dbe592 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -396,151 +411,93 @@ class SquadService extends Actor {
                 }
                 memberPosition.Close()
                 UpdateSquadListWhenListed(squad, listingChanged)
-                SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Closed)))
-                UpdateListedSquadDetail(squad.GUID, squad)
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Closed)))
+                )
               case Some(false) | None => ;
             }
 
           case AddSquadMemberPosition(position) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(false) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
                 squad.Availability.update(position, true)
                 UpdateSquadListWhenListed(squad, SquadInfo().Capacity(squad.Capacity))
-                SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Open)))
-                UpdateListedSquadDetail(squad.GUID, squad)
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Open)))
+                )
               case Some(true) | None => ;
             }
 
           case ChangeSquadMemberRequirementsRole(position, role) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
                 squad.Membership(position).Role = role
-                SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Role(role))))
-                UpdateListedSquadDetail(squad.GUID, squad)
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Role(role))))
+                )
               case Some(false) | None => ;
             }
 
           case ChangeSquadMemberRequirementsDetailedOrders(position, orders) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
                 squad.Membership(position).Orders = orders
-                SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().DetailedOrders(orders))))
-                UpdateListedSquadDetail(squad.GUID, squad)
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().DetailedOrders(orders))))
+                )
               case Some(false) | None => ;
             }
 
           case ChangeSquadMemberRequirementsCertifications(position, certs) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
                 squad.Membership(position).Requirements = certs
-                SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Requirements(certs))))
-                UpdateListedSquadDetail(squad.GUID, squad)
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Requirements(certs))))
+                )
               case Some(false) | None => ;
             }
 
           case LocationFollowsSquadLead(state) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
             if(state) {
               log.info(s"${tplayer.Name}-${tplayer.Faction} has moves the rally to the leader's position")
             }
             else {
               log.info(s"${tplayer.Name}-${tplayer.Faction} has let the rally move freely")
             }
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.LocationFollowsSquadLead = state
 
           case AutoApproveInvitationRequests(state) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
             if(state) {
               log.info(s"${tplayer.Name}-${tplayer.Faction} is allowing all requests to join the squad")
             }
             else {
               log.info(s"${tplayer.Name}-${tplayer.Faction} has started screening invitation requests")
             }
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.AutoApproveInvitationRequests = state
 
-          case SelectRoleForYourself(position) =>
-            //TODO need to ask permission from the squad leader, unless our character is the squad leader or already currently in the squad
-            squadOpt match {
-              case Some(squad) if squad.GUID == guid || squad.Leader.Name == tplayer.Name =>
-                //already a member of this squad, or the leader; swap positions freely
-                val membership = squad.Membership.zipWithIndex
-                val toMember = squad.Membership(position)
-                if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
-                  //acquire this membership position
-                  membership.find { case (member, _) => member.Name == tplayer.Name } match {
-                    case Some((fromMember, fromIndex)) =>
-                      //copy member details
-                      toMember.Name = fromMember.Name
-                      toMember.CharId = fromMember.CharId
-                      toMember.Health = fromMember.Health
-                      toMember.Armor = fromMember.Armor
-                      toMember.Position = fromMember.Position
-                      toMember.ZoneId = fromMember.ZoneId
-                      //old membership no longer valid
-                      fromMember.Name = ""
-                      fromMember.CharId = 0L
-                      if(fromIndex == squad.LeaderPositionIndex) {
-                        squad.LeaderPositionIndex = position
-                      }
-                      membership
-                        .collect({ case (_member, _) if _member.CharId > 0 => _member.Name })
-                        .foreach { name =>
-                          SquadEvents.publish(SquadServiceResponse(s"$name/Squad", SquadResponse.SwapMember(squad, fromIndex, position)))
-                        }
-                    case None =>
-                      toMember.Name = tplayer.Name
-                      toMember.CharId = tplayer.CharId
-                      toMember.Health = StatConverter.Health(tplayer.Health, tplayer.MaxHealth, min = 1, max = 64)
-                      toMember.Armor = StatConverter.Health(tplayer.Armor, tplayer.MaxArmor, min = 1, max = 64)
-                      toMember.Position = tplayer.Position
-                      toMember.ZoneId = 13
-                      memberToSquad(tplayer.CharId) = squad
-                  }
-                }
-                UpdateSquadDetail(squad.GUID, squad)
-
-              case Some(_) =>
-                //not a member of the requesting squad; do nothing
-              case None =>
-                //not a member of any squad; consider request of joining the target squad
-                idToSquad.get(guid) match {
-                  case Some(squad) =>
-                    val member = squad.Membership(position)
-                    if(squad.Availability(position) && member.CharId == 0 &&
-                      tplayer.Certifications.intersect(member.Requirements) == member.Requirements) {
-                      bids(tplayer.CharId) = NormalBid(squad.Leader.CharId, guid, position)
-                      val leader = squad.Leader
-                      //TODO need to ask permission from the squad leader, unless auto-approve is in effect
-                      sender ! SquadServiceResponse("", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, leader.CharId, Some(tplayer.CharId), leader.Name, false, None))
-                    }
-
-                  case None =>
-                  //squad does not exist!? assume old data
-                  //reload squad list data and blank the squad definition the user is looking at
-                }
-            }
-
           case RequestListSquad() =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-            if(!squad.Listed) {
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+            if(!squad.Listed && squad.Task.nonEmpty && squad.ZoneId > 0) {
               log.info(s"${tplayer.Name}-${tplayer.Faction} has opened public recruitment for squad ${squad.Task}")
               squad.Listed = true
               sender ! SquadServiceResponse("", SquadResponse.InitSquad(squad.GUID))
               UpdateSquadList(squad, None)
-              sender ! SquadServiceResponse("", SquadResponse.Unknown17(squad, tplayer.CharId))
             }
 
           case StopListSquad() =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
-            if(!squad.Listed) {
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+            if(squad.Listed) {
               log.info(s"${tplayer.Name}-${tplayer.Faction} has closed public recruitment for squad ${squad.Task}")
               squad.Listed = false
               sender ! SquadServiceResponse("", SquadResponse.InitSquad(PlanetSideGUID(0)))
@@ -548,41 +505,101 @@ class SquadService extends Actor {
             }
 
           case ResetAll() =>
-            squadOpt match {
-              case Some(squad) if squad.Leader.CharId == tplayer.CharId =>
-                squad.Task = ""
-                squad.ZoneId = None
-                squad.Availability.indices.foreach { i =>
-                  squad.Availability.update(i, true)
-                }
-                squad.Membership.foreach(position => {
-                  position.Role = ""
-                  position.Orders = ""
-                  position.Requirements = Set()
-                })
-                squad.LocationFollowsSquadLead = false
-                squad.AutoApproveInvitationRequests = false
-                UpdateSquadList(squad, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
-                UpdateSquadDetail(squad.GUID, squad)
-              case None => ;
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+            squad.Task = ""
+            squad.ZoneId = None
+            squad.Availability.indices.foreach { i =>
+              squad.Availability.update(i, true)
+            }
+            squad.Membership.foreach(position => {
+              position.Role = ""
+              position.Orders = ""
+              position.Requirements = Set()
+            })
+            squad.LocationFollowsSquadLead = false
+            squad.AutoApproveInvitationRequests = false
+            UpdateSquadListWhenListed(squad, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
+            UpdateSquadDetailWhenListed(squad.GUID, squad)
+
+          case _ =>
+        }
+        // etc..
+        (pSquadOpt, action) match {
+          //the following action can be performed by the squad leader and maybe an unaffiliated player
+          case (Some(squad), SelectRoleForYourself(position)) =>
+            log.info(s"${tplayer.Name} would like the #${position+1} spot in this squad")
+            val membership = squad.Membership.zipWithIndex
+            val toMember = squad.Membership(position)
+            //the squad leader may swap to any open position; a normal member has to validate against requirements
+            if((squad.Leader.CharId == tplayer.CharId && toMember.CharId == 0) || ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
+              membership.find { case (member, _) => member.CharId == tplayer.CharId } match {
+                case Some((fromMember, fromIndex)) =>
+                  SwapMemberPosition(squad, toMember, fromMember)
+                  if(fromIndex == squad.LeaderPositionIndex) {
+                    squad.LeaderPositionIndex = position
+                  }
+                  membership
+                    .filter { case (_member, _) => _member.CharId > 0 }
+                    .foreach { case (_member, _) =>
+                      SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromIndex, position)))
+                    }
+                  UpdateSquadDetailWhenListed(squad.GUID, squad)
+                case _ => ;
+                //somehow, this is not our squad; do nothing, for now
+              }
+            }
+            else {
+              //not qualified for requested position
             }
 
-          case DisplaySquad() =>
+          //the following action can be performed by an unaffiliated player
+          case (None, SelectRoleForYourself(position)) =>
+            //not a member of any squad, but we might become a member of this one
             idToSquad.get(guid) match {
               case Some(squad) =>
-                sender ! SquadServiceResponse(s"${tplayer.Name}/Squad", GenSquadDetail(squad.GUID, squad))
+                val toMember = squad.Membership(position)
+                if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
+                  //we could join but we may need permission from the squad leader first
+                  log.info(s"Player ${tplayer.Name} would like to join the squad ${squad.Task}.")
+                  bids(tplayer.CharId) = NormalBid(squad.Leader.CharId, guid, position)
+                  //val leader = squad.Leader
+                  //TODO ask permission from the squad leader, unless auto-approve is in effect
+                  self ! SquadServiceMessage(tplayer, SquadAction.Membership(SquadRequestType.Accept, tplayer.CharId, None, "", None))
+                }
               case None => ;
+              //squad does not exist? assume old local data; force update to correct discrepancy
             }
 
-//          case AnswerSquadJoinRequest() =>
-//            idToSquad.get(guid) match {
-//              case Some(squad) =>
-//                if(squad.Leader.Name == tplayer.Name && squad.Listed) {
-//                  //squad was just listed but we have not yet declared ourselves as the leader
-//                  UpdateSquadDetail(squad)
-//                }
-//              case None => ;
-//            }
+          //the following action can be performed by ???
+          case (Some(squad), AssignSquadMemberToRole(position, char_id)) =>
+            val membership = squad.Membership.zipWithIndex
+            (membership.find({ case (member, _) => member.CharId == char_id}), membership(position)) match {
+              case (Some((fromMember, fromPosition)), (toMember, _)) =>
+                val name = fromMember.Name
+                SwapMemberPosition(squad, toMember, fromMember)
+                //
+                membership
+                  .filter({ case (_member, _) => _member.CharId > 0 })
+                  .foreach { case (_member, _) =>
+                    SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromPosition, position)))
+                  }
+                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                  SquadDetail().Members(List(
+                    SquadPositionEntry(position, SquadPositionDetail().CharId(fromMember.CharId).Name(fromMember.Name)),
+                    SquadPositionEntry(fromPosition, SquadPositionDetail().CharId(char_id).Name(name))
+                  ))
+                )
+              case _ => ;
+            }
+
+          //the following action can be performed by anyone
+          case (_, DisplaySquad()) =>
+            idToSquad.get(guid) match {
+              case Some(squad) =>
+                viewDetails(tplayer.CharId) = guid
+                sender ! SquadServiceResponse(s"/${tplayer.CharId}/Squad", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+              case None => ;
+            }
 
           case _ => ;
         }
@@ -595,15 +612,15 @@ class SquadService extends Actor {
   def JoinSquad(player : Player, squad : Squad, line : Int) : Boolean = {
     val charId = player.CharId
     val position = squad.Membership(line)
-    if(squad.Availability(line) && position.CharId == 0 &&
-      player.Certifications.intersect(position.Requirements) == position.Requirements) {
+    if(ValidOpenSquadPosition(squad, line, position, player.Certifications)) {
+      log.info(s"Player ${player.Name} will join the squad ${squad.Task} at position ${line+1}!")
       position.Name = player.Name
       position.CharId = charId
       position.Health = StatConverter.Health(player.Health, player.MaxHealth, min=1, max=64)
       position.Armor = StatConverter.Health(player.Armor, player.MaxArmor, min=1, max=64)
       position.Position = player.Position
       position.ZoneId = 13
-      memberToSquad(player.CharId) = squad
+      memberToSquad(charId) = squad
 
       val size = squad.Size
       if(size == 1) {
@@ -612,28 +629,34 @@ class SquadService extends Actor {
       }
       else if(size == 2) {
         //first squad member after leader; both members fully initialize
-        val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+        val indices = squad.Membership.zipWithIndex
+          .collect({ case (member, index) if member.CharId != 0 => index }).toList
         squad.Membership
-          .collect({ case member if member.CharId != 0 => member.CharId })
-          .foreach { charId =>
-            SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", SquadResponse.Join(squad, indices)))
+          .filterNot { _.CharId == 0 }
+          .foreach { member =>
+            SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", SquadResponse.Join(squad, indices)))
           }
+        //fully update for all users
+        UpdateSquadDetail(squad.GUID, squad)
       }
       else {
         //joining an active squad; everybody updates differently
         //new member gets full UI updates
-        sender ! SquadServiceResponse("", SquadResponse.Join(
-          squad,
-          squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
-        ))
+        val indices = squad.Membership.zipWithIndex
+          .collect({ case (member, index) if member.CharId != 0 => index }).toList
+        SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Join(squad, indices)))
         //other squad members see us joining the squad
         val updatedIndex = List(line)
         squad.Membership
-          .collect({ case member if member.CharId != 0 && member.CharId != charId => member.CharId })
-          .foreach { charId =>
-            SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", SquadResponse.Join(squad, updatedIndex)))
+          .filterNot { member => member.CharId == 0 || member.CharId == charId }
+          .foreach { member =>
+            SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", SquadResponse.Join(squad, updatedIndex)))
           }
+        UpdateSquadDetailWhenListed(squad.GUID, squad,
+          SquadDetail().Members(List(SquadPositionEntry(line, SquadPositionDetail().CharId(charId).Name(player.Name))))
+        )
       }
+      UpdateSquadListWhenListed(squad, SquadInfo().Size(size))
       true
     }
     else {
@@ -641,6 +664,86 @@ class SquadService extends Actor {
     }
   }
 
+  def LeaveSquad(player : Player, squad : Squad) : Boolean = {
+    val charId = player.CharId
+    val membership = squad.Membership.zipWithIndex
+    membership.find { case (_member, _) => _member.CharId == charId } match {
+      case Some((member, index)) =>
+        val updateList = membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
+        memberToSquad.remove(charId)
+        member.Name = ""
+        member.CharId = 0
+
+        val size = squad.Size
+        if(size < 2) {
+          //squad is rendered to just one person or less; collapse it
+          squad.Membership.foreach { _member =>
+              SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
+          }
+          CloseOutSquad(squad, membership, updateList)
+        }
+        else {
+          //squad continues, despite player's parting
+          //member leaves the squad completely
+          sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
+          //other squad members see the member leaving
+          val leavingMember = List((charId, index))
+          membership
+            .filter { case (_member, _) => _member.CharId > 0 }
+            .foreach { case (_member, _) =>
+              SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
+            }
+        }
+        true
+      case None =>
+        false
+    }
+  }
+
+  def CloseOutSquad(squad : Squad) : Unit = {
+    val membership = squad.Membership.zipWithIndex
+    CloseOutSquad(
+      squad,
+      membership,
+      membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
+    )
+  }
+
+  def CloseOutSquad(squad : Squad, membership : Iterable[(Member, Int)], updateList : List[(Long, Int)]) : Unit = {
+    val leaderCharId = squad.Leader.CharId
+    membership.foreach {
+      case (member, _) =>
+        val charId = member.CharId
+        member.Name = ""
+        member.CharId = 0L
+        memberToSquad.remove(charId)
+        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad, updateList)) )
+    }
+    idToSquad.remove(squad.GUID)
+  }
+
+  def SwapMemberPosition(squad : Squad, toMember : Member, fromMember : Member) : Unit = {
+    val (name, charId, zoneId, pos, health, armor) = (fromMember.Name, fromMember.CharId, fromMember.ZoneId, fromMember.Position, fromMember.Health, fromMember.Armor)
+    if(toMember.CharId > 0) {
+      fromMember.Name = toMember.Name
+      fromMember.CharId = toMember.CharId
+      fromMember.ZoneId = toMember.ZoneId
+      fromMember.Position = toMember.Position
+      fromMember.Health = toMember.Health
+      fromMember.Armor = toMember.Armor
+    }
+    else {
+      fromMember.Name = ""
+      fromMember.CharId = 0L
+    }
+    toMember.Name = name
+    toMember.CharId = charId
+    toMember.ZoneId = zoneId
+    toMember.Position = pos
+    toMember.Health = health
+    toMember.Armor = armor
+  }
+
   def UpdateSquadList(squad : Squad, changes : SquadInfo) : Unit = {
     UpdateSquadList(squad, Some(changes))
   }
@@ -650,7 +753,7 @@ class SquadService extends Actor {
   }
 
   def UpdateSquadListWhenListed(squad : Squad, changes : Option[SquadInfo]) : Unit = {
-    if(squad.Listed) {
+    if(squad.Listed || squad.Size > 1) {
       UpdateSquadList(squad, changes)
     }
   }
@@ -673,7 +776,7 @@ class SquadService extends Actor {
             log.info(s"Squad will be updated")
             factionListings(index) = entry
             SquadEvents.publish(
-              SquadServiceResponse(s"$faction/Squad", SquadResponse.UpdateList(Seq((index, changedFields))))
+              SquadServiceResponse(s"/$faction/Squad", SquadResponse.UpdateList(Seq((index, changedFields))))
             )
           case None =>
             //remove squad from listing
@@ -681,7 +784,7 @@ class SquadService extends Actor {
             factionListings.remove(index)
             SquadEvents.publish(
               //SquadServiceResponse(s"$faction/Squad", SquadResponse.RemoveFromList(Seq(index)))
-              SquadServiceResponse(s"$faction/Squad", SquadResponse.InitList(factionListings.toVector))
+              SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
             )
         }
       case None =>
@@ -689,40 +792,33 @@ class SquadService extends Actor {
         log.info(s"Squad will be introduced")
         factionListings += entry
         SquadEvents.publish(
-          SquadServiceResponse(s"$faction/Squad", SquadResponse.InitList(factionListings.toVector))
+          SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
         )
     }
   }
 
-  def GenSquadDetail(guid : PlanetSideGUID, squad : Squad) : SquadResponse.Detail = {
-    SquadResponse.Detail(
-      squad.GUID,
-      squad.Leader.Name,
-      squad.Task,
-      PlanetSideZoneID(squad.ZoneId),
-      squad.Membership.zipWithIndex.map({ case (p, index) =>
-        if(squad.Availability(index)) {
-          SquadPositionDetail(p.Role, p.Orders, p.Requirements, p.CharId, p.Name)
-        }
-        else {
-          SquadPositionDetail.Closed
-        }
-      }).toList
-    )
+  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    UpdateSquadDetailWhenListed(guid, squad, SquadService.Detail.Publish(squad))
   }
 
-  def UpdateListedSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    if(squad.Listed) {
-      UpdateSquadDetail(guid, squad)
+  def UpdateSquadDetailWhenListed(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    if(squad.Listed || squad.Size > 1) {
+      UpdateSquadDetail(guid, squad, SquadService.Detail.Publish(squad))
     }
   }
 
-  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    val detail = GenSquadDetail(guid, squad)
+  def UpdateSquadDetailWhenListed(guid : PlanetSideGUID, squad : Squad, detail : SquadDetail) : Unit = {
+    if(squad.Listed || squad.Size > 1) {
+      UpdateSquadDetail(guid, squad, detail)
+    }
+  }
+
+  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad, detail : SquadDetail) : Unit = {
+    val output = SquadResponse.Detail(guid, detail)
     squad.Membership
-      .collect { case member if member.CharId > 0L => member.CharId }
-      .foreach { charId =>
-        SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", detail))
+      .filter { _.CharId > 0L }
+      .foreach { member =>
+        SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", output))
       }
   }
 }
@@ -734,7 +830,7 @@ object SquadService {
 
   final case class VacancyBid(char_id : Long, squad_guid : PlanetSideGUID) extends PositionBid
 
-  final case class CamraderieBid(char_id : Long, placeholder : Squad) extends PositionBid
+  final case class SpontaneousBid(char_id : Long, placeholder : Squad) extends PositionBid
 
   object SquadList {
     def Publish(squad : Squad) : SquadInfo = {
@@ -768,86 +864,6 @@ object SquadService {
         )
         .Complete
     }
-
-    def Differences(updates : List[Int], info : SquadDetail) : SquadDetail = {
-      if(updates.nonEmpty) {
-        val list = Seq(
-          SquadDetail.Blank, //must be index-0
-          SquadDetail(info.unk1, None, None, None, None, None, None, None, None),
-          SquadDetail(None, None, info.leader_char_id, None, None, None, None, None, None),
-          SquadDetail(None, None, None, info.unk3, None, None, None, None, None),
-          SquadDetail(None, None, None, None, info.leader_name, None, None, None, None),
-          SquadDetail(None, None, None, None, None, info.task, None, None, None),
-          SquadDetail(None, None, None, None, None, None, info.zone_id, None, None),
-          SquadDetail(None, None, None, None, None, None, None, info.unk7, None),
-          SquadDetail(None, None, None, None, None, None, None, None, info.member_info)
-        )
-        var out = SquadDetail.Blank
-        updates
-          .map(i => list(i))
-          .filterNot { _ == SquadDetail.Blank }
-          .foreach(sinfo => out = out And sinfo )
-        out
-      }
-      else {
-        SquadDetail.Blank
-      }
-    }
-
-    def Differences(before : SquadDetail, after : SquadDetail) : SquadDetail = {
-      SquadDetail(
-        if(!before.unk1.equals(after.unk1)) after.unk1 else None,
-        None,
-        if(!before.leader_char_id.equals(after.leader_char_id)) after.leader_char_id else None,
-        if(!before.unk3.equals(after.unk3)) after.unk3 else None,
-        if(!before.leader_name.equals(after.leader_name)) after.leader_name else None,
-        if(!before.task.equals(after.task)) after.task else None,
-        if(!before.zone_id.equals(after.zone_id)) after.zone_id else None,
-        if(!before.unk7.equals(after.unk7)) after.unk7 else None,
-        {
-          (before.member_info, after.member_info) match {
-            case (Some(beforeEntry), Some(afterEntry)) =>
-              val out = beforeEntry.zip(afterEntry)
-                .map { case (b, a) => PositionEquality(b, a) }
-                .collect { case Some(entry) => entry }
-              if(out.nonEmpty) {
-                Some(out)
-              }
-              else {
-                None
-              }
-            case _ =>
-              None
-          }
-        }
-      )
-    }
-
-    private def PositionEquality(before : SquadPositionEntry, after : SquadPositionEntry) : Option[SquadPositionEntry] = {
-      (before.info, after.info) match {
-        case (Some(binfo), Some(ainfo)) =>
-          val out = MemberEquality(binfo, ainfo)
-          if(out == SquadPositionDetail.Blank) {
-            None
-          }
-          else {
-            Some(SquadPositionEntry(before.index, out))
-          }
-        case _ =>
-          None
-      }
-    }
-
-    private def MemberEquality(before : SquadPositionDetail, after : SquadPositionDetail) : SquadPositionDetail = {
-      SquadPositionDetail(
-        if(!before.is_closed.equals(after.is_closed)) after.is_closed else None,
-        if(!before.role.equals(after.role)) after.role else None,
-        if(!before.detailed_orders.equals(after.detailed_orders)) after.detailed_orders else None,
-        if(!before.requirements.equals(after.requirements)) after.requirements else None,
-        if(!before.char_id.equals(after.char_id)) after.char_id else None,
-        if(!before.name.equals(after.name)) after.name else None
-      )
-    }
   }
 
   def LoadSquadDefinition(squad : Squad, favorite : SquadLoadout) : Unit = {
